﻿using System;
using System.Threading;
using System.Windows.Forms;
using System.Text; // StringBuilder
using System.Drawing; // Point
using System.Runtime.InteropServices;
using System.Collections; // ArrayList
using System.Diagnostics; // Process
using Microsoft.Win32; // Registry
using System.Reflection; // Assembly
using System.Security.Principal;
using System.Media; // SystemSounds
using System.Configuration; // ConfigurationManager
using System.Text.RegularExpressions;

namespace WinCycle
{
    public partial class AltTabForm : Form
    {
        IntPtr ptrHook;
        Win32andMore.LowLevelKeyboardProc objKeyboardProcess;
        ArrayList windowHandles = new ArrayList();
        public bool wantToClose = false; // isOnScreen
        public const uint WM_KEYDOWN = 0x0100, WM_KEYUP = 0x0101;
        bool isElevated;
        Keys altTabKey = Keys.RWin, modifierKey = Keys.Control;
        Version curVersion = Assembly.GetExecutingAssembly().GetName().Version;
        SplashScreen frmAbout = null;

        private IntPtr CaptureKey(int nCode, IntPtr wp, IntPtr lp)
        {
            if (nCode >= 0)
            {
                Win32andMore.KBDLLHOOKSTRUCT objKeyInfo = (Win32andMore.KBDLLHOOKSTRUCT)Marshal.PtrToStructure(lp, typeof(Win32andMore.KBDLLHOOKSTRUCT));
                if (objKeyInfo.key == altTabKey) // Keys.RWin
                {
                    if (wp == (IntPtr)WM_KEYUP)
                    {
                        windowHandles.Clear();
                        Win32andMore.EnumWindows(new Win32andMore.EnumWindowsCallback(MyCallback), 0);
                        IntPtr asIntPtr = GetHandleForRWin(windowHandles);
                        if (asIntPtr != IntPtr.Zero)
                        {
                            ActivateWindowByHandle(asIntPtr);
                        }
                        else Console.Beep();
                    } return (IntPtr)1; //Return a dummy value to trap the keystroke
                }
            } return Win32andMore.CallNextHookEx(ptrHook, nCode, wp, lp); //The event wasn't handled, pass it to next application
        }

        private bool MyCallback(int hWnd, int lParam)
        {
            windowHandles.Add(hWnd);
            return true;
        }

        private void NoAdminRights(IntPtr destHwnd)
        {
            string msgText = "UAC prevents interaction with this administrative program.\n\nThat's why " + Application.ProductName + " will restart and ask for higher privileges!";
            Console.Beep();
            uint processID = 0;
            Win32andMore.GetWindowThreadProcessId(destHwnd, out processID);
            Process proc = Process.GetProcessById(Convert.ToInt32(processID));
            if (TopMostMsgBox.Show("Target window: " + proc.MainWindowTitle + Environment.NewLine + Environment.NewLine + msgText, Win32andMore.GetDescription(), MessageBoxButtons.OKCancel) == DialogResult.OK)
                RestartElevated();
        }

        public AltTabForm()
        {
            InitializeComponent();
            CheckForIllegalCrossThreadCalls = false;
            isElevated = Win32andMore.IsUserAnAdmin(); // Windows-API
            Win32andMore.SetAutorun(true);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetDesktopLocation(MousePosition.X - 54, MousePosition.Y - 30); //Location = new Point(MousePosition.X - 5, MousePosition.Y - 20);
            ProcessModule objCurrentModule = Process.GetCurrentProcess().MainModule;
            objKeyboardProcess = new Win32andMore.LowLevelKeyboardProc(CaptureKey);
            ptrHook = Win32andMore.SetWindowsHookEx(13, objKeyboardProcess, Win32andMore.GetModuleHandle(objCurrentModule.ModuleName), 0);
            Text = Application.ProductName + " " + new Regex(@"^\d+\.\d+").Match(curVersion.ToString()).Value;
            System.Drawing.Rectangle workingRectangle = Screen.PrimaryScreen.WorkingArea;
            MaximumSize = new System.Drawing.Size(workingRectangle.Width - 10, workingRectangle.Height - 10);
            MinimumSize = new System.Drawing.Size(this.Width, this.Height); // no smaller than design time size
            Win32andMore.EnumWindows(new Win32andMore.EnumWindowsCallback(MyCallback), 0);
            showListView(windowHandles);
            //notifyIconAltTab.ShowBalloonTip(8000, Win32andMore.GetDescription(), "Press »Right Windows Key« to switch back\r\nand forth between two Windows programs.", ToolTipIcon.Info);
            try { modifierKey = (Keys)Enum.Parse(typeof(Keys), ConfigurationManager.AppSettings["ModifierKey"]); }
            catch { /* on error, the default setting remains (modifierKey = Keys.Control) */ }
            try { altTabKey = (Keys)Enum.Parse(typeof(Keys), ConfigurationManager.AppSettings["AltTabKey"]); }
            catch { /* on error, the default setting remains (altTabKey = Keys.RWin) */ }
            string keyText = altTabKey.Equals(Keys.RWin) ? "Right Windows Key" : altTabKey.ToString();
            notifyIconAltTab.Text = "Press »" + keyText + "« to cycle between open windows.";
        }

        private IntPtr GetHandleForRWin(ArrayList al)
        {
            bool modifierNotDown = false;
            if ((ModifierKeys & modifierKey) == 0) { modifierNotDown = true; }
            var idx = 0;
            IntPtr indexHwnd = IntPtr.Zero;
            IntPtr ownerHwnd = IntPtr.Zero;
            IntPtr foundHwnd = IntPtr.Zero;
            foreach (int i in al)
            {
                try
                {
                    indexHwnd = new IntPtr(i);
                    if (Win32andMore.IsWindowVisible(indexHwnd) && indexHwnd != Handle)
                    {
                        ownerHwnd = indexHwnd;
                        do
                        {
                            ownerHwnd = Win32andMore.GetWindow(ownerHwnd, Win32andMore.GW_OWNER);
                        } while (!IntPtr.Zero.Equals(Win32andMore.GetWindow(ownerHwnd, Win32andMore.GW_OWNER)));
                        ownerHwnd = ownerHwnd != IntPtr.Zero ? ownerHwnd : indexHwnd;
                        if (Win32andMore.GetLastActivePopup(ownerHwnd) == indexHwnd)
                        {
                            int es = Win32andMore.GetWindowLongPtr(indexHwnd, Win32andMore.GWL_EXSTYLE);
                            if ((!(((es & Win32andMore.WS_EX_TOOLWINDOW) == Win32andMore.WS_EX_TOOLWINDOW) && ((es & Win32andMore.WS_EX_APPWINDOW) != Win32andMore.WS_EX_APPWINDOW))) && !IsInvisibleWin10BackgroundAppWindow(indexHwnd))
                            {
                                idx++;
                                if (modifierNotDown && idx == 2) { return indexHwnd; }
                                else { foundHwnd = indexHwnd; }
                            }
                        }
                    }
                }
                catch (Exception ex) { MessageBox.Show(ex.Message); }
            }
            return foundHwnd; // return IntPtr.Zero;
        }

        private void showListView(ArrayList al)
        {
            imageList.Images.Clear(); //clear current imagelist.
            listView1.Clear();
            listView1.Columns.Add(columnHeader1); // is deleted by Clear()
            listView1.Columns.Add(columnHeader2);
            listView1.Columns.Add(columnHeader3);
            IntPtr indexHwnd = IntPtr.Zero;
            IntPtr ownerHwnd = IntPtr.Zero;
            foreach (int i in al)
            {
                try
                {
                    indexHwnd = new IntPtr(i);
                    if (Win32andMore.IsWindowVisible(indexHwnd) && indexHwnd != Handle)
                    {
                        ownerHwnd = indexHwnd;
                        do
                        {
                            ownerHwnd = Win32andMore.GetWindow(ownerHwnd, Win32andMore.GW_OWNER);
                        } while (!IntPtr.Zero.Equals(Win32andMore.GetWindow(ownerHwnd, Win32andMore.GW_OWNER)));
                        ownerHwnd = ownerHwnd != IntPtr.Zero ? ownerHwnd : indexHwnd;
                        if (Win32andMore.GetLastActivePopup(ownerHwnd) == indexHwnd)
                        {
                            int es = Win32andMore.GetWindowLongPtr(indexHwnd, Win32andMore.GWL_EXSTYLE);
                            if ((!(((es & Win32andMore.WS_EX_TOOLWINDOW) == Win32andMore.WS_EX_TOOLWINDOW) && ((es & Win32andMore.WS_EX_APPWINDOW) != Win32andMore.WS_EX_APPWINDOW))) && !IsInvisibleWin10BackgroundAppWindow(indexHwnd))
                            {
                                StringBuilder name = new StringBuilder(255);
                                Win32andMore.GetWindowText(i, name, 255);
                                try
                                {// 32-Bit-Prozesse
                                    uint pid = 0;
                                    Win32andMore.GetWindowThreadProcessId(indexHwnd, out pid);
                                    Process p = Process.GetProcessById((int)pid);
                                    string fName = p.MainModule.FileName;
                                    Icon iconForFile = Icon.ExtractAssociatedIcon(fName);
                                    Image img = iconForFile.ToBitmap(); // macht das Bild feiner
                                    imageList.Images.Add(img); // imageList.Images.Add(iconForFile);
                                }
                                catch
                                {// 32-Bit-Prozess kann nicht auf 64-Bit Prozesse zugreifen
                                    Icon iconForFile = SystemIcons.WinLogo;
                                    Image img = iconForFile.ToBitmap();
                                    imageList.Images.Add(img);
                                }
                                ListViewItem item = new ListViewItem("", imageList.Images.Count - 1);
                                item.SubItems.Add(i.ToString());
                                item.SubItems.Add(name.ToString());
                                listView1.Items.Add(item);
                            }
                        }
                    }
                }
                catch (Exception ex) { MessageBox.Show(ex.Message); }
            }
            if (listView1.Items.Count > 0) { listView1.Items[0].Selected = true; }
            int lvWidth = 0; // resize listview
            listView1.Width = 200; // origin size
            listView1.BeginUpdate();
            foreach (ColumnHeader column in listView1.Columns)
            {// To autosize to the width of the column heading, set the Width property to -2."
                column.Width = -2;
                lvWidth += column.Width;
            }
            listView1.Width = lvWidth + 1 + listView1.Columns.Count; // Addition wg. Grid?!
            Width = listView1.Width + 8;

            if (listView1.Items.Count > 0)
            {
                listView1.Height = (listView1.GetItemRect(0).Height) * (listView1.Items.Count) + 4; // listView1.Items.Count + 2;
                Height = listView1.Height; // +88;
            }
            listView1.EndUpdate();
        }

        private bool IsInvisibleWin10BackgroundAppWindow(IntPtr hWindow)
        {
            int cloakedVal;
            int hr = Win32andMore.DwmGetWindowAttribute(hWindow, Win32andMore.DWMWA_CLOAKED, out cloakedVal, sizeof(int));
            if (hr != 0) // returns S_OK (which is zero) on success. Otherwise, it returns an HRESULT error code
            {
                cloakedVal = 0;
            }
            return cloakedVal != 0 ? true : false;
        }

        private void RefreshList()
        {
            windowHandles.Clear();
            Win32andMore.EnumWindows(new Win32andMore.EnumWindowsCallback(MyCallback), 0);
            showListView(windowHandles);
        }

        private void WinActivate()
        {
            if (listView1.SelectedItems != null)
            {
                IntPtr asIntPtr = new IntPtr(Convert.ToInt32(listView1.SelectedItems[0].SubItems[1].Text));
                ActivateWindowByHandle(asIntPtr);
            }
        }

        private void ActivateWindowByHandle(IntPtr hwnd)
        {
            // The system restricts which processes can set the foreground window.
            // A process can set the foreground window only if one of the following conditions is true:
            // • The process is the foreground process.
            // • The process was started by the foreground process.
            // • The process received the last input event.
            // • There is no foreground process.
            // • The foreground process is being debugged.
            // • The foreground is not locked (see LockSetForegroundWindow).
            // • The foreground lock time-out has expired (see SPI_GETFOREGROUNDLOCKTIMEOUT in SystemParametersInfo).
            // • No menus are active.
            try
            {
                if (!isElevated && Win32andMore.IsProcessOwnerAdmin(hwnd))
                {
                    NoAdminRights(hwnd);
                }
                else
                {
                    if (Win32andMore.IsWindow(hwnd))
                    {// If a background application calls SetForegroundWindow(), Windows will flash the taskbar button for the app, but will not actually bring the app to the front. 
                        Win32andMore.SetForegroundWindow(Handle); // BringToFront();
                        uint targetThreadID = Win32andMore.GetWindowThreadProcessId(hwnd, IntPtr.Zero);
                        uint mainThreadID = Win32andMore.GetCurrentThreadId();
                        bool is_attached_my_to_fore = false, is_attached_fore_to_target = false;
                        uint foreThreadID = 0;
                        IntPtr origForegroundHwnd = Win32andMore.GetForegroundWindow();
                        if (origForegroundHwnd != IntPtr.Zero)
                        {
                            foreThreadID = Win32andMore.GetWindowThreadProcessId(origForegroundHwnd, IntPtr.Zero);
                            if (foreThreadID != 0 && mainThreadID != foreThreadID)
                                is_attached_my_to_fore = Win32andMore.AttachThreadInput(mainThreadID, foreThreadID, true);
                            if (foreThreadID != 0 && targetThreadID != 0 && foreThreadID != targetThreadID)
                                is_attached_fore_to_target = Win32andMore.AttachThreadInput(foreThreadID, targetThreadID, true);
                        }
                        for (int i = 0; i < 5; i++)
                        {
                            if (Win32andMore.IsIconic(hwnd)) //if ((Win32andMore.GetWindowLongPtr(hwnd, Win32andMore.GWL_STYLE) & Win32andMore.WS_MINIMIZE) == Win32andMore.WS_MINIMIZE)
                            {
                                if (!Win32andMore.ShowWindow(hwnd, Win32andMore.SW_RESTORE)) { continue; } //SendMessage(asIntPtr, WM_SYSCOMMAND, (IntPtr)SC_RESTORE, (IntPtr)0);
                            }
                            if (Win32andMore.SetForegroundWindow(hwnd)) break;
                        }
                        if (is_attached_my_to_fore)
                            Win32andMore.AttachThreadInput(mainThreadID, foreThreadID, false);
                        if (is_attached_fore_to_target)
                            Win32andMore.AttachThreadInput(foreThreadID, targetThreadID, false);
                    }
                    if (Win32andMore.GetForegroundWindow() != hwnd) { SystemSounds.Beep.Play(); }
                    Application.DoEvents(); // before RefreshList
                }
            }
            catch (ArgumentOutOfRangeException ex) { MessageBox.Show(ex.Message); }
        }

        private void WinClose()
        {
            if (listView1.SelectedItems != null)
            {
                try
                {
                    IntPtr asIntPtr = new IntPtr(Convert.ToInt32(listView1.SelectedItems[0].SubItems[1].Text));
                    if (!isElevated && Win32andMore.IsProcessOwnerAdmin(asIntPtr))
                    {
                        NoAdminRights(asIntPtr);
                    }
                    else
                    {
                        Win32andMore.PostMessage(asIntPtr, Win32andMore.WM_CLOSE, IntPtr.Zero, IntPtr.Zero);
                    }
                }
                catch (Exception e) { MessageBox.Show(e.Message); }
                Application.DoEvents(); // RefreshList();
            }
        }

        private void listView1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            WinActivate();
            Hide();
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Escape) Hide();
            if (e.KeyCode == Keys.Enter) { WinActivate(); Hide(); }
            if (e.KeyCode == Keys.Delete) WinClose();
            if (e.KeyCode == Keys.F5) RefreshList();
        }

        private void listView1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Escape) this.Close();
            if (e.KeyCode == Keys.Enter) { WinActivate(); Hide(); }
            if (e.KeyCode == Keys.Delete) WinClose();
            if (e.KeyCode == Keys.F5) RefreshList();
        }

        private void WinCycleListeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            ToggleAltTabWindow();
        }

        private void ToggleAltTabWindow()
        {
            if (Visible) { Hide(); }
            else
            {// Opacity = 1.00; 
                RefreshList();
                Show();
                ShowInTaskbar = true;
                Activate();
            }
        }

        private void notifyIconAltTab_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left) { ToggleAltTabWindow(); }
        }

        private void AltTabForm_Shown(object sender, EventArgs e)
        {
            Hide();
            Opacity = 1.00;
        }

        private void AltTabForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            Hide(); //MoveOffScreen(this); // Opacity = 0.00;
            if (!wantToClose) e.Cancel = true; // this cancels the close event.
        }

        private void progammBeendenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Hide();
            if (frmAbout != null) frmAbout.Close();
            ClosingForm frmClosing = null;
            if ((frmClosing = (ClosingForm)Win32andMore.IsFormAlreadyOpen(typeof(ClosingForm))) == null)
            {
                using (frmClosing = new ClosingForm())
                {
                    if (frmClosing.ShowDialog() == DialogResult.OK)
                    {
                        if (frmClosing.ClosingForm_rbSecond.Checked)
                        {
                            Win32andMore.SetAutorun(false);
                        }
                        frmClosing.Close();
                        wantToClose = true;
                        Close();
                    } // DialogResult.OK
                } // using
            }
            else frmClosing.BringToFront();
        }

        private void infoUndHilfeToolStripMenuItem_Click(object sender, EventArgs e)
        {// allow only one instance
            SplashScreen frmAbout = null;
            if ((frmAbout = (SplashScreen)Win32andMore.IsFormAlreadyOpen(typeof(SplashScreen))) == null)
            {
                frmAbout = new SplashScreen();
                frmAbout.Show();
            }
            else frmAbout.BringToFront();
        }

        public void RestartElevated()
        {
            ProcessStartInfo startInfo = new ProcessStartInfo();
            startInfo.UseShellExecute = true;
            startInfo.WorkingDirectory = Environment.CurrentDirectory;
            startInfo.FileName = Application.ExecutablePath;
            startInfo.Verb = "runas";
            try { Process p = Process.Start(startInfo); }
            catch (System.ComponentModel.Win32Exception) { return; }
            wantToClose = true;
            Application.Exit();
        }

        private void refreshListToolStripMenuItem_Click(object sender, EventArgs e)
        {
            RefreshList();
        }

        private void activateWindowToolStripMenuItem_Click(object sender, EventArgs e)
        {
            WinActivate();
            RefreshList(); // Reihenfolge geändert
        }

        private void closeWindowDeleteToolStripMenuItem_Click(object sender, EventArgs e)
        {
            WinClose();
            RefreshList();
        }

    }
}
