﻿using System;
using System.Threading;
using System.Windows.Forms;
using System.Text; // StringBuilder
using System.Drawing; // Point
using System.Runtime.InteropServices;
using System.Collections; // ArrayList
using System.Diagnostics; // Process
using Microsoft.Win32; // Registry
using System.Reflection; // Assembly
using System.Timers;
using System.Security.Principal;

namespace WinCycle
{
    class Win32andMore
    {
        [StructLayout(LayoutKind.Sequential)]
        public struct KBDLLHOOKSTRUCT
        {
            public Keys key;
            public int scanCode;
            public int flags;
            public int time;
            public IntPtr extra;
        }

        public delegate IntPtr LowLevelKeyboardProc(int nCode, IntPtr wParam, IntPtr lParam);

        public const int DWMWA_CLOAKED = 14;

        [DllImport("DwmApi.dll")]
        public static extern int DwmGetWindowAttribute(IntPtr hwnd, int dwAttributeToGet, out int pvAttributeValue, int cbAttribute);

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern IntPtr SetWindowsHookEx(int id, LowLevelKeyboardProc callback, IntPtr hMod, uint dwThreadId);

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern bool UnhookWindowsHookEx(IntPtr hook);

        [DllImport("user32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern IntPtr CallNextHookEx(IntPtr hook, int nCode, IntPtr wp, IntPtr lp);

        [DllImport("kernel32.dll", CharSet = CharSet.Auto, SetLastError = true)]
        public static extern IntPtr GetModuleHandle(string name);

        [DllImport("user32.dll")]
        public extern static int EnumWindows(EnumWindowsCallback lpEnumFunc, int lParam);

        //[DllImport("user32.dll", CharSet = CharSet.Auto)]
        //public static extern int RegisterShellHookWindow(IntPtr hwnd);

        [DllImport("user32.dll")]
        public static extern bool PostMessage(IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam);

        [DllImport("user32.dll")]
        public static extern int GetWindowText(int hWnd, StringBuilder lpString, uint bufferSize);

        [DllImport("user32.dll")]
        public static extern IntPtr GetLastActivePopup(IntPtr hWnd);

        [DllImport("user32.dll", CharSet = CharSet.Auto, ExactSpelling = true)]
        public static extern IntPtr GetWindow(IntPtr hWnd, int flags);

        [DllImport("user32.dll", EntryPoint = "GetWindowLong")]
        public static extern int GetWindowLongPtr32(IntPtr hWnd, int nIndex);

        [DllImport("user32.dll", EntryPoint = "GetWindowLongPtr")]
        public static extern int GetWindowLongPtr64(IntPtr hWnd, int nIndex);

        //[DllImport("user32.dll")]
        //public static extern int GetWindowTextLength(IntPtr hWnd);

        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool IsWindowVisible(IntPtr hWnd);

        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool SetForegroundWindow(IntPtr hWnd);

        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool ShowWindow(IntPtr hWnd, int nCmdShow);

        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool IsWindow(IntPtr hWnd);

        [DllImport("user32.dll")]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool IsIconic(IntPtr hWnd);

        [DllImport("user32.dll")]
        public static extern IntPtr GetForegroundWindow();

        [DllImport("kernel32.dll")]
        public static extern uint GetCurrentThreadId();

        [DllImport("user32.dll", SetLastError = true)]
        public static extern uint GetWindowThreadProcessId(IntPtr hWnd, out uint lpdwProcessId);

        [DllImport("user32.dll")]
        public static extern uint GetWindowThreadProcessId(IntPtr hWnd, IntPtr ProcessId);

        [DllImport("user32.dll")]
        public static extern bool AttachThreadInput(uint idAttach, uint idAttachTo, bool fAttach);

        public static int GetWindowLongPtr(IntPtr hWnd, int nIndex)
        {// This static method is required because Win32 does not support GetWindowLongPtr directly
            if (IntPtr.Size == 8)
                return GetWindowLongPtr64(hWnd, nIndex);
            else
                return GetWindowLongPtr32(hWnd, nIndex);
        }

        [DllImport("shell32.dll")]
        public static extern bool IsUserAnAdmin();

        [DllImport("advapi32.dll", SetLastError = true)]
        public static extern bool OpenProcessToken(IntPtr ProcessHandle, UInt32 DesiredAccess, out IntPtr TokenHandle);

        [DllImport("kernel32.dll", SetLastError = true)]
        public static extern bool CloseHandle(IntPtr hObject);

        public delegate bool EnumWindowsCallback(int hWnd, int lParam);
        private const int STANDARD_RIGHTS_REQUIRED = 0xF0000;
        private const int TOKEN_ASSIGN_PRIMARY = 0x1;
        private const int TOKEN_DUPLICATE = 0x2;
        private const int TOKEN_IMPERSONATE = 0x4;
        private const int TOKEN_QUERY = 0x8;
        private const int TOKEN_QUERY_SOURCE = 0x10;
        private const int TOKEN_ADJUST_GROUPS = 0x40;
        private const int TOKEN_ADJUST_PRIVILEGES = 0x20;
        private const int TOKEN_ADJUST_SESSIONID = 0x100;
        private const int TOKEN_ADJUST_DEFAULT = 0x80;
        private const int TOKEN_ALL_ACCESS = (STANDARD_RIGHTS_REQUIRED | TOKEN_ASSIGN_PRIMARY | TOKEN_DUPLICATE | TOKEN_IMPERSONATE | TOKEN_QUERY | TOKEN_QUERY_SOURCE | TOKEN_ADJUST_PRIVILEGES | TOKEN_ADJUST_GROUPS | TOKEN_ADJUST_SESSIONID | TOKEN_ADJUST_DEFAULT);
        public const int GWL_EXSTYLE = (-20);
        public const int GWL_STYLE = (-16);
        public const int GW_OWNER = 4;
        public const uint WS_MINIMIZE = 0x20000000;
        public const uint WS_EX_TOOLWINDOW = 0x00000080;
        public const uint WS_EX_APPWINDOW = 0x40000; // provides a taskbar button for a window that would otherwise lack one
        public const int SW_SHOWDEFAULT = 10;
        public const int SW_RESTORE = 9; // restores the window if it is minimized and activates the window
        public const int WM_CLOSE = 0x0010;

        public static bool IsProcessOwnerAdmin(IntPtr hWnd)
        {
            uint processID = 0;
            GetWindowThreadProcessId(hWnd, out processID);
            Process proc = Process.GetProcessById(Convert.ToInt32(processID));
            IntPtr ph = IntPtr.Zero;
            try { OpenProcessToken(proc.Handle, TOKEN_ALL_ACCESS, out ph); }
            catch { return true; } // tritt zwangsläufig ein, wenn ein höher privilegierte Prozess abgefragt werden soll.
            WindowsIdentity iden = new WindowsIdentity(ph);
            bool result = false;
            foreach (IdentityReference role in iden.Groups)
            {
                if (role.IsValidTargetType(typeof(SecurityIdentifier)))
                {
                    SecurityIdentifier sid = role as SecurityIdentifier;
                    if (sid.IsWellKnown(WellKnownSidType.AccountAdministratorSid) || sid.IsWellKnown(WellKnownSidType.BuiltinAdministratorsSid))
                    {
                        result = true; break;
                    }
                }
            }
            CloseHandle(ph);
            return result;
        }

        public static void SetAutorun(bool enable)
        {
            string appName = Application.ProductName;
            string runKey = @"SOFTWARE\Microsoft\Windows\CurrentVersion\Run";
            RegistryKey regKey = Registry.CurrentUser.OpenSubKey(runKey);
            if (regKey == null) // Key nicht vorhanden, wird angelegt
            {
                Registry.CurrentUser.CreateSubKey(runKey);
            }
            if (enable)
            {
                if (regKey.GetValue(appName) == null)
                {
                    regKey.Close();
                    regKey = Registry.CurrentUser.OpenSubKey(runKey, true);
                    regKey.SetValue(appName, "\"" + Assembly.GetExecutingAssembly().Location.ToString() + "\"");
                    regKey.Close();
                }
            }
            else
            {
                try
                {
                    regKey = Registry.CurrentUser.OpenSubKey(runKey, true);
                    regKey.DeleteValue(appName, false);
                    regKey.Close();
                }
                catch { } // Es ist kein Registry-Schlüssel mit diesem Namen vorhanden!
            }
        }

        public static string GetDescription()
        {
            Type clsType = typeof(SplashScreen); // FormMoLiStar
            Assembly assy = clsType.Assembly;
            AssemblyDescriptionAttribute adAttr =
                (AssemblyDescriptionAttribute)Attribute.GetCustomAttribute(
                assy, typeof(AssemblyDescriptionAttribute));
            if (adAttr == null) return String.Empty;
            return adAttr.Description;
        }

        public static Form IsFormAlreadyOpen(Type formType)
        {
            foreach (Form openForm in Application.OpenForms)
                if (openForm.GetType() == formType) return openForm;
            return null;
        }
    }
}

